=== ns-3.45/contrib/nr/Makefile ===
# Copyright (c) 2022 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
#
# SPDX-License-Identifier: GPL-2.0-only

all:
	@echo "Usage: make docs"

docs:
	doxygen doc/doxygen.conf
