=== debian/changelog ===
ns3 (3.45-1) unstable; urgency=medium

  * New upstream version.
  * Disable the documentation package to save space on the servers.
    It's probably more useful on the ns-3 web server anyway.
  * Remove the now unused build-dep on goocanvas (Closes: #1112443).

 -- Martin Quinson <mquinson@debian.org>  Fri, 29 Aug 2025 17:16:44 +0200

ns3 (3.44-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Quinson <mquinson@debian.org>  Thu, 20 Mar 2025 10:53:57 +0100
